"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chunk = exports.rotate = exports.repeat = exports.once = void 0;
var once = function (fn) {
    var cache;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (cache) {
            return cache;
        }
        else {
            cache = fn.apply(void 0, args);
            return cache;
        }
    };
};
exports.once = once;
var createArray = function (times) { return Array(times).fill(undefined); };
var repeat = function (times, factory) { return createArray(times).map(function (_, i) { return factory(i); }); };
exports.repeat = repeat;
var rotate = function (n, arr) { return arr.slice(n, arr.length).concat(arr.slice(0, n)); };
exports.rotate = rotate;
var chunk = function (size, arr) {
    return exports.repeat(Math.ceil(arr.length / size), function (index) { return index * size; }).map(function (begin) { return arr.slice(begin, begin + size); });
};
exports.chunk = chunk;
//# sourceMappingURL=lambda.js.map