"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.maybe = exports.none = exports.just = void 0;
var react_1 = __importDefault(require("fast-deep-equal/es6/react"));
var lambda_1 = require("../lambda");
var adt_builder_1 = require("../utils/adt-builder");
var serializer_1 = require("../utils/serializer");
var builder = adt_builder_1.createAdtBuilder({});
var just = function (value) {
    return builder.flatten(value).seal(function (data) { return (__assign(__assign({}, serializer_1.createSerializer('just', data)), { isJust: true, isNone: false, equals: function (operand) {
            return operand.fold(function () { return false; }, function (it) { return react_1.default(it, data); });
        }, fold: function (_, ifJust) { return (ifJust ? ifJust(data) : data); }, map: function (ifJust) { return exports.maybe(ifJust(data)); }, mapIf: function (predicate, ifTrue) { return (predicate(data) ? exports.maybe(ifTrue(data)) : exports.maybe(data)); }, orElse: function () { return exports.maybe(data); } })); });
};
exports.just = just;
var VOID = (function () {
})();
exports.none = lambda_1.once(function () {
    return builder.flatten(VOID).seal(function () { return ({
        toJSON: function () { return null; },
        toString: function () { return "none()"; },
        isJust: false,
        isNone: true,
        equals: function (operand) {
            return operand.fold(function () { return true; }, function () { return false; });
        },
        map: function () { return exports.none(); },
        mapIf: function () { return exports.none(); },
        orElse: function (ifNone) { return exports.maybe(ifNone()); },
        fold: function (ifNone) { return (ifNone ? ifNone() : VOID); },
    }); });
});
var isNonNullable = function (data) {
    try {
        return !!Object.getPrototypeOf(data);
    }
    catch (_) {
        return false;
    }
};
var maybe = function (value) { return (isNonNullable(value) ? exports.just(value) : exports.none()); };
exports.maybe = maybe;
//# sourceMappingURL=maybe.js.map