"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAdtBuilder = void 0;
var createAdtBuilder = function (prototype) {
    var seal = function (adt) { return Object.freeze(Object.assign(Object.create(prototype), adt)); };
    var hasSamePrototype = function (data) {
        try {
            return Object.getPrototypeOf(data) === prototype;
        }
        catch (_) {
            return false;
        }
    };
    return {
        flatten: function (value) { return ({
            seal: function (factory) { return (hasSamePrototype(value) ? value : seal(factory(value))); },
        }); },
    };
};
exports.createAdtBuilder = createAdtBuilder;
//# sourceMappingURL=adt-builder.js.map