import { Either, LeftValueOrEither, RightValueOrEither } from '../either/either.types';
export declare type Validation<E, A> = Either<E[], A>;
declare type ValidationFailureValue<E> = LeftValueOrEither<E> | LeftValueOrEither<E[]>;
declare type ValidationIO<A> = (data: A) => RightValueOrEither<A>;
export declare const pass: <E = [Error, "Please specify E type in pass<E, A>"], A = [Error, "Please specify A type in pass<E, A>"]>(data: RightValueOrEither<A>) => Either<E[], A>;
export declare const fail: <E = [Error, "Please specify E type in fail<E, A>"], A = [Error, "Please specify A type in fail<E, A>"]>(data: ValidationFailureValue<E>) => Either<E[], A>;
export declare const validate: <E = never, A = never>(data: RightValueOrEither<A>, validations: ValidationIO<A>[]) => Either<E[], A>;
export {};
