"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = exports.fail = exports.pass = void 0;
var either_1 = require("../either/either");
var pass = function (data) { return either_1.right(data); };
exports.pass = pass;
var fail = function (data) { return either_1.left(data).mapLeft(function (it) { return (Array.isArray(it) ? it : [it]); }); };
exports.fail = fail;
var validate = function (data, validations) {
    var lefts = validations.reduce(function (acc, validate) {
        var out = exports.pass(data).map(validate);
        return out.isLeft ? acc.concat(out.fold()) : acc;
    }, []);
    return lefts.length ? exports.fail(lefts) : exports.pass(data);
};
exports.validate = validate;
//# sourceMappingURL=validation.js.map